/* Priority Task List
 * jcelmam@uoc.edu
 * Javier Celma Márquez
 * Projecte Final de carrera
 * categoriesListDelete.js
 * */

Ti.include('config.js');

//Creating root window and adding controls
var win = Titanium.UI.currentWindow;

var data = [];	

var tableCategories = Titanium.UI.createTableView({
	data:data,
	maxRowHeigth:80,
	minRowHeigth:60,
	top:50
});
win.add(tableCategories);

var imageCategories = Ti.UI.createImageView({
	image:'images/categorieslist.png',
	top:10,
	width:200,
	height:40,
	left:5
});
win.add(imageCategories);

var user;

//function to refresh table data when focus
function setData() {
	
data = [];

if (BH.authorized()) {
	
//getUserName function in the classes diagram
//api call to get the user name connected to Twitter
BH.api("https://api.twitter.com/1/account/verify_credentials.json", 
		'GET', 
		'include_status=true',
		function(user){
			if (user == false) {
        		alert('The Twitter Api call fails. Try Again.');
        	}else{
				user_connected = JSON.parse(user);
				user_connected = user_connected.screen_name;
			}

//getCategoriesFromTweets function in the classes diagram
//api call to get the tweets like '@username;...' the user connected to Twitter
BH.api("http://search.twitter.com/search.json", 
					'GET', 
					'q=' + Ti.Network.encodeURIComponent(user_connected) , 
					function(e){
					        	if (e == false) {
					        		alert('The Twitter Api call fails. Try Again.');
					        	}else{
					        	user = JSON.parse(e);
				        	
				        	if (typeof(user.results)=='object' && user.results.length>0) {
				        		var temp = [];
					        	for (var i=0;i<user.results.length;i++) {
									var twit = user.results[i].text.split(';');

									if (typeof(temp)=='object' && temp.length>0) {
										var insert = 1;
										for (var j=0;j<temp.length && insert == 1;j++) {
											if (temp[j] == twit[1]) {
												var insert = 0;
											}
											else{
												var insert = 1;
											}
										}
										
										if (insert == 1) {
											temp.push(twit[1]);
											data.push(Titanium.UI.createTableViewRow({
												title: twit[1],
												hasChild: true,
												color: 'black'
											}));
										}
										
									} else {
										temp.push(twit[1]);
										data.push(Titanium.UI.createTableViewRow({
										title: twit[1],
										hasChild: true,
										color: 'black'
										
									}));
								}
									
									
								}
							}
					        	
					        
					        tableCategories.setData([]);
					        tableCategories.setData(data);
							
	
							
					}
	         });					
	         					
		});
					
	}
	         
}

//Event listeners

//goToTasksDeleteFromCategory function in the class diagram
//Go to the page of Delete Tasks with the category selected
tableCategories.addEventListener('click', function(e){
	
    var win1 = Titanium.UI.createWindow({  
        backgroundColor:'#fff',
        title: 'Tasks',
		url:'tasksDelete.js'
    }); 
    
    win1.indexTable = e.index;
    win1.category = data[e.index].title;
    win1.user_connected = user_connected;
    win1.title = data[e.index].title + ' Tasks';
    
	Titanium.UI.currentTab.open(win1,{
		animation:true
		});

});

//refreshList function in the class diagram		
//Refresh table data when focus								
win.addEventListener('focus', function(){
	
	tableCategories.setData([]);
	if(Ti.Platform.osname == 'android'){
	
		setTimeout(function()
			{
				setData();
			},1);
		
	} else{
	
	var navActInd = Titanium.UI.createActivityIndicator();
	win.setRightNavButton(navActInd);
	navActInd.show();
	
	setTimeout(function()
		{
			setData();
			navActInd.hide();
			win.setRightNavButton(null);
		},1);

	}

	tableCategories.show();
	
});


