/* Priority Task List
 * jcelmam@uoc.edu
 * Javier Celma Márquez
 * Projecte Final de carrera
 * newTask.js
 * */

Ti.include('config.js');

//Creating root window and adding controls
var win = Titanium.UI.currentWindow;

var labelCategory =  Ti.UI.createLabel({
		text: 'Category',
		color: 'black',
		top:10,
		left:20,
		width:80,
		height:30
	});
	
win.add(labelCategory);

//Category attribute
var category = Titanium.UI.createTextField({
    color:'#336699',
    height:40,
    top:40,
    left:20,
    width:250,
    maxlength:30,
    borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED
});

win.add(category); 

//Task attribute
var labelTask =  Ti.UI.createLabel({
		text: 'Task',
		color: 'black',
		top:75,
		left:20,
		width:50,
		height:30
	});
	
win.add(labelTask);

var task = Titanium.UI.createTextField({
    color:'#336699',
    height:40,
    top:105,
    left:20,
    width:250,
    maxlength:30,
    borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED
});

win.add(task);

//Priority attribute
var labelPriority =  Ti.UI.createLabel({
		text: 'Priority',
		color: 'black',
		top:140,
		left:20,
		width:150,
		height:30
	});

win.add(labelPriority);

var transformPicker = Titanium.UI.create2DMatrix().scale(0.6);
var priority = Ti.UI.createPicker({
  top:110,
  left:70,
  transform:transformPicker,
  heigth: 70,
  width: 250
});

if (Ti.Platform.osname == 'android'){
	priority.top = 180;
	priority.heigth = 100;
	priority.left = 20;
	priority.transform = null;
}

var data = [];
data[0]=Ti.UI.createPickerRow({title:'High'});
data[1]=Ti.UI.createPickerRow({title:'Medium'});
data[2]=Ti.UI.createPickerRow({title:'Low'});
 
priority.add(data);
priority.selectionIndicator = true;
 
win.add(priority);
 
// must be after picker has been displayed
priority.setSelectedRow(0, 1, false); // select Medium

var addTask = Titanium.UI.createButton({
   title: 'Add Task',
   top: 300,
   width: 200,
   height: 50
});

if (Ti.Platform.osname == 'ipad'){
	addTask.left = 70;
}

win.add(addTask);


//Event Listeners
var twit = '';
addTask.addEventListener('click',function(e)
{
	if (validateForm() == true){
   
	   		Titanium.API.info("You clicked the button form validated");
	  
			   if (BH.authorized()) {
			   	
					var prior = priority.getSelectedRow(0).title;
					if (prior == 'High') {
						prior = 1;
					}
					if (prior == 'Medium') {
						prior = 2;
					}
					if (prior == 'Low') {
						prior = 3;
					}
			   			
				   	//getUserName function in the classes diagram
					//api call to get the user name connected to Twitter
				   	BH.api("https://api.twitter.com/1/account/verify_credentials.json", 
							'GET', 
							'include_status=true',
							function(user){
								user = JSON.parse(user);
								user = user.screen_name;
								Titanium.API.info(user);
								twit = '@' + user  + ';'+ category.value  + ';' + task.value + ';' + prior;
							Titanium.API.info(twit);
						
						//addTask function in the classes diagram
						//api call to twit the message
					   BH.api("https://api.twitter.com/1/statuses/update.json", 
							'POST', 
							'status=' + Ti.Network.encodeURIComponent(twit) , 
							function(e){
							        	if (e == false){
							        		alert('Failed, this task already has been added');
							        	} else  {
							            	alert("Successfully added Task");
							            	//clean the form
							            	task.value='';
							            	priority.setSelectedRow(0, 1, false);
							            }
							         });
					         
					}
			);
			
   	   
	} else{
		alert('Not logged in');
	}
   }
   
});


//validateForm

function validateForm() {
	if (category.value == '') {
		alert('no category value');
		return false;
	}
	if (task.value == '') {
		alert('no task value');
		return false;
	}
	
	return true;
	
}