/* Priority Task List
 * jcelmam@uoc.edu
 * Javier Celma Márquez
 * Projecte Final de carrera
 * tasks.js
 * */

Ti.include('config.js');

//Creating root window and adding controls
var win = Titanium.UI.currentWindow;

//rescue index
var index = win.indexTable;
//rescue category
var category = win.category;
//rescue user_connected
var user_connected = win.user_connected;


var data = [];
var dataCompleted = [];
var dataIncompleted = [];

var tableTasks = Titanium.UI.createTableView({
	data:data,
	maxRowHeigth:80,
	minRowHeigth:60,
	top:60
	});

var taskstitle = Titanium.UI.createLabel({
   text: 'All Tasks - Tap to complete tasks',
   font:{
   	fontsize:18,
    fontfamily:'Verdana'
   },
   top: 30,
   width: 250,
   left: 10,
   height: 40,
   color: 'blue'
});
win.add(taskstitle);

var tableTasksCompleted = Titanium.UI.createTableView({
	maxRowHeigth:80,
	minRowHeigth:60,
	top:60
	});
	
var tableTasksIncompleted = Titanium.UI.createTableView({
	maxRowHeigth:80,
	minRowHeigth:60,
	top:60
	});
var all = Titanium.UI.createButton({
   title: 'All',
   top: 0,
   left:0,
   width: 110,
   height: 40
});

var complete = Titanium.UI.createButton({
   title: 'Completed',
   top: 0,
   left:105,
   width: 110,
   height: 40
});

var incomplete = Titanium.UI.createButton({
   title: 'Incompleted',
   top: 0,
   width: 110,
   left: 210,
   height: 40
});

//function to refresh table data with the typelist (ALL,COMPLETED,INCOMPLETED)
function setData(typelist) {

data = [];
dataCompleted = [];
dataIncompleted = [];

BH.api("https://api.twitter.com/1/statuses/user_timeline.json", 
					'GET', 
					'count=50' , 
					function(e){
					        	if (e == false) {
					        		//sometimes API fails here, try the call again 
					        		setData(typelist);
					        		}
					        	else{
					        		
					        	var search = JSON.parse(e);
					        	
					        	//order the tasks by priority
				        	    search.sort(comparePrior);
				        	    search.reverse();
				        	    
				        	    //getTasksFromTweets function in the class diagram
				        		if (typeof(search)=='object' && search.length>0) {
				        			
						        	for (var i=0;i<search.length;i++) {
						        		Ti.API.info(search[i].id_str);
										var twit = search[i].text.split(';');
										if (twit[1] == category) {
										
										var row  = Ti.UI.createTableViewRow({
												height : 'auto',
												textAlign : 'left',
												id_twit: search[i].id_str,
												hasCheck: search[i].favorited,
												height:60
											});
										
										if (twit[3] == 1) {
											row.backgroundColor = '#FF8494';
										}
										if (twit[3] == 2) {
											row.backgroundColor = '#82ECFF';
										}
										if (twit[3] == 3) {
											row.backgroundColor = '#D0FFAF';
										}
											
										var labelTask = Titanium.UI.createLabel({
												color:'black',
												left:5,
												text:twit[2]
											});
											row.add(labelTask);
											
											var prior;
											if (twit[3] == 1) {
												prior = 'high';
											}
											if (twit[3] == 2) {
												prior = 'medium';
											}
											if (twit[3] == 3) {
												prior = 'low';
											}
											
											
											var labelPriority = Titanium.UI.createLabel({
												color:'red',
												left:200,
												text:'(' + prior.toUpperCase() + ')'
											});
											if (twit[3] == '1') {
												labelPriority.color = 'red';
											}
											if (twit[3]  == '2') {
												labelPriority.color = 'blue';
											}
											if (twit[3]  == '3') {
												labelPriority.color = 'green';
											}
											row.add(labelPriority);
											
											//data for the table tasks
											data.push(row);

											//data for the table tasks completed
											if (row.hasCheck){
												dataCompleted.push(row);
											}
											//data for the table tasks Incompleted
											else{
												dataIncompleted.push(row);
											}
										}
	
					        	}

					        	//orderListByPriority function in the class diagram
					        	//compare function to order array
					        	function comparePrior(a, b) {
									return b.text.substring(b.text.length - 1, b.text.length) - a.text.substring(a.text.length - 1, a.text.length);
								}

							
							tableTasks.setData([]);
							tableTasksCompleted.setData([]);
							tableTasksIncompleted.setData([]);
							
							if(typelist == 'ALL'){
								tableTasks.setData(data);
							} 
							if(typelist == 'COMPLETED'){
								tableTasksCompleted.setData(dataCompleted);
							} 
							if(typelist == 'INCOMPLETED'){
								tableTasksIncompleted.setData(dataIncompleted);
							} 
							
							
				        }
				        
//Event listeners on the tableTasks        
tableTasks.addEventListener('click', function(e){
	//incompleteTask function in the class diagram
	if (data[e.index].hasCheck == true) {
		BH.api("https://api.twitter.com/1/favorites/destroy/" + data[e.index].id_twit + '.json', 
					'POST' ,
					'',
					function(l){
						if (l != false) {
							data[e.index].hasCheck = false;
							tableTasks.setData(data);
						}
					});
	}
	else{
		//completeTask function in the class diagram
		BH.api("https://api.twitter.com/1/favorites/create/" + data[e.index].id_twit + '.json', 
					'POST' ,
					'',
					function(l){
						if (l != false) {						
							data[e.index].hasCheck = true;
							tableTasks.setData(data);
						}
					});
					
		
	}
});


}



});



}

//showAll function in the class diagram (when comes from Categories)
win.addEventListener('focus', function(){

	setTimeout(function()
	{
		var data = setData('ALL');
	},1);

		tableTasksCompleted.hide();
		tableTasksIncompleted.hide();
		tableTasks.show();
	
});

//showAll function in the class diagram (when comes from Tasks)
all.addEventListener('click', function(){

taskstitle.text = 'All Tasks - Tap to complete tasks';

setTimeout(function()
	{
		var data = setData('ALL');
	},1);

		tableTasksCompleted.hide();
		tableTasksIncompleted.hide();
		tableTasks.show();
	
});

//showComplete function in the class diagram
complete.addEventListener('click', function(){

taskstitle.text = 'Completed Tasks';
setTimeout(function()
	{
		var dataCompleted = setData('COMPLETED');
	},1);

		tableTasks.hide();
		tableTasksIncompleted.hide();
		tableTasksCompleted.show();
			
});

//showIncomplete function in the class diagram
incomplete.addEventListener('click', function(){

taskstitle.text = 'Incompleted Tasks';

	setTimeout(function()
	{
		var dataInCompleted = setData('INCOMPLETED');
	},1);

		tableTasks.hide();
		tableTasksCompleted.hide();
		tableTasksIncompleted.show();
	
});

//for android closes window when tap the back button we have to regenerate tabs
win.addEventListener('android:back', function (e) {
	Ti.include('App.js');
	setTabGroup(1);
});


win.add(all);
win.add(complete);
win.add(incomplete);


win.add(tableTasks);
win.add(tableTasksCompleted);
win.add(tableTasksIncompleted);
