/* Priority Task List
 * jcelmam@uoc.edu
 * Javier Celma Márquez
 * Projecte Final de carrera
 * tasksDelete.js
 * */

Ti.include('config.js');

//Creating root window and adding controls
var win = Titanium.UI.currentWindow;

//rescue index
var index = win.indexTable;
//rescue category
var category = win.category;
//rescue user_connected
var user_connected = win.user_connected;


var data = [];

var tableTasks = Titanium.UI.createTableView({
	data:data,
	maxRowHeigth:80,
	minRowHeigth:60,
	top:60
	});
win.add(tableTasks);

var taskstitle = Titanium.UI.createLabel({
   text: 'Tap to delete',
   font:{
   	fontSize:18,
    fontfamily:'Verdana'
   },
   top: 10,
   width: 250,
   left: 10,
   height: 40,
   color: 'blue'
});
win.add(taskstitle);

//showAll function in the class diagram
var search_tasks = '@' + user_connected + ';' + category;
BH.api("http://search.twitter.com/search.json", 
					'GET', 
					'q=' + Ti.Network.encodeURIComponent(search_tasks) , 
					function(e){
					        	if (e == false) {
					        		//sometimes API fails here, try the call again 
					        		alert('API call Failed');
					        		}
					        	else{
					        	var search = JSON.parse(e);
					        	//order the tasks by priority
				        	    search.results.sort(comparePrior);
				        	    search.results.reverse();
				        	    
				        	    //getTasksFromTweets function in the class diagram
				        		if (typeof(search.results)=='object' && search.results.length>0) {
				        			
						        	for (var i=0;i<search.results.length;i++) {
						        		Ti.API.info(search.results[i].id);
										var twit = search.results[i].text.split(';');
										
										var row  = Ti.UI.createTableViewRow({
												height : 'auto',
												textAlign : 'left',
												id_tweet : search.results[i].id_str,
												height:60
											});
										
										if (twit[3] == 1) {
											row.backgroundColor = '#FF8494';
										}
										if (twit[3] == 2) {
											row.backgroundColor = '#82ECFF';
										}
										if (twit[3] == 3) {
											row.backgroundColor = '#D0FFAF';
										}
	
									var labelTask = Titanium.UI.createLabel({
											color:'black',
											left:5,
											text:twit[2]
										});
										row.add(labelTask);
										
										var prior;
										if (twit[3] == 1) {
											prior = 'high';
										}
										if (twit[3] == 2) {
											prior = 'medium';
										}
										if (twit[3] == 3) {
											prior = 'low';
										}
										
										
										var labelPriority = Titanium.UI.createLabel({
											color:'red',
											left:200,
											text:'(' + prior.toUpperCase() + ')'
										});
										if (twit[3] == '1') {
											labelPriority.color = 'red';
										}
										if (twit[3]  == '2') {
											labelPriority.color = 'blue';
										}
										if (twit[3]  == '3') {
											labelPriority.color = 'green';
										}
										row.add(labelPriority);
									
										data.push(row);
										
					        	}
					        	
					        	//orderListByPriority function in the class diagram
					        	//compare function to order array
					        	function comparePrior(a, b) {
									return b.text.substring(b.text.length - 1, b.text.length) - a.text.substring(a.text.length - 1, a.text.length);
								}
							
							tableTasks.setData([]);
							tableTasks.setData(data);
							tableTasks.show();
				        }

//deleteMarkedTask function in the class diagram				        
//mark the task to delete
tableTasks.addEventListener('click', function(e){
	
	var alertDialog = Titanium.UI.createAlertDialog({
    title: 'Are you sure?',
    message: 'Do you want to delete the marked task?',
    buttonNames: ['Yes','No'],
    cancel: 1
	});
 
	alertDialog.addEventListener('click',function(l){
	    if (l.index == 0) {
	        var data = tableTasks.data[0].rows;

			    BH.api("https://api.twitter.com/1/statuses/destroy/" + data[e.index].id_tweet + '.json', 
						'POST', 
						'', 
						function(g){
							if(g != false){
								tableTasks.deleteRow(e.index);
								data = tableTasks.data[0].rows;
							}
						});
	        
		        tableTasks.setData([]);
				tableTasks.setData(data);
				tableTasks.show();
	    }
	});
 
alertDialog.show();
	
	
	});
}
});


//for android closes window when tap the back button we have to regenerate tabs
win.addEventListener('android:back', function (e) {
	Ti.include('App.js');
	setTabGroup(2);
});
