/**
 * Appcelerator Titanium Mobile
 * Copyright (c) 2010 by TaskList, Inc. All Rights Reserved.
 * Licensed under the terms of the Apache Public License
 * Please see the LICENSE included with this distribution for details.
 * 
 * WARNING: This is generated code. Modify at your own risk and without support.
 */

#import "TiDimension.h"
#import "TiUtils.h"


const TiDimension TiDimensionZero = {TiDimensionTypeDip, 0};
const TiDimension TiDimensionAuto = {TiDimensionTypeAuto, 0};
const TiDimension TiDimensionAutoSize = {TiDimensionTypeAutoSize, 0};
const TiDimension TiDimensionAutoFill = {TiDimensionTypeAutoFill, 0};
const TiDimension TiDimensionUndefined = {TiDimensionTypeUndefined, 0};

TiDimension TiDimensionMake(TiDimensionType type, CGFloat value)
{
	if ((value!=0)&&(!isnormal(value))) {
		NSLog(@"[FATAL] Invalid dimension value (%f) requested. Making the dimension undefined instead.",value);
		return TiDimensionUndefined;
	}
	if (!((value > -1e5)&&(value < 1e5))) {
		NSLog(@"[FATAL] Extreme dimension value (%f) requested. Allowing, just in case this is intended.",value);
	}
	TiDimension dimension;
	dimension.type = type;
	dimension.value = value;
	return dimension;
}

CGFloat convertInchToPixels(CGFloat value)
{
    return [TiUtils dpi]*value;
}

CGFloat convertPixelsToDip(CGFloat value)
{
    if ([TiUtils isRetinaDisplay]) {
        return value/2;
    }
    return value;
}

CGFloat convertDipToInch(CGFloat value)
{
    if ([TiUtils isRetinaDisplay]) {
        return (value*2)/[TiUtils dpi];
    }
    return value/[TiUtils dpi];
}



